<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <link rel="stylesheet" href="css.css">
</head>
<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" href="#">Navbar</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
  
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active ">
          <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
          
        </li>
        <li class="nav-item">
          <a class="nav-link" href="#">Link</a>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Dropdown
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <a class="dropdown-item" href="#">Action</a>
            <a class="dropdown-item" href="#">Another action</a>
            <div class="dropdown-divider"></div>
            <a class="dropdown-item" href="#">Something else here</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link disabled" href="#">Disabled</a>
        </li>
      </ul>
      <form class="form-inline my-2 my-lg-0">
        <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
        <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
      </form>
    </div>
  </nav>
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="#">Home</a></li>
      <li class="breadcrumb-item" aria-current="page"><a href="#">List User</a></li>
    </ol>
  </nav>
  
  <div class="sidebar">
    <a class="active" href="#home">Home</a>
    <a href="#news">News</a>
    <a href="#contact">Contact</a>
    <a href="#about">About</a>
  </div>
  <!--  Content-->
  <div class="container">
    <h2 style="text-align: center;">Danh sách người dùng</h2>
    
    <table class="table table-bordered table-striped table-hover" id="table-users">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>
  
  <!-- Modal user detail-->
  <div>
    <div class="modal fade" id="modal-user-detail" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">User detail information</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <label class="col-form-label col-sm-4">User Id</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="input-user-id">
                </div>
              </div>
              <div class="row form-group">
                <label class="col-form-label col-sm-4">First Name</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="input-firstname">
                </div>
              </div>
              <div class="row form-group">
                <label class="col-form-label col-sm-4">Last Name</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="input-lastname">
                </div>
              </div>
              <div class="row form-group">
                <label class="col-form-label col-sm-4">Age</label>
                <div class="col-sm-8">
                  <input type="text" class="form-control" id="input-age">
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- -->
    <!-- Site footer -->
    <footer class="site-footer">
      <div class="container">
        <div class="row">
          <div class="col-sm-12 col-md-6">
            <h6>About</h6>
            <p class="text-justify">Scanfcode.com <i>CODE WANTS TO BE SIMPLE </i> is an initiative  to help the upcoming programmers with the code. Scanfcode focuses on providing the most efficient code or snippets as the code wants to be simple. We will help programmers build up concepts in different programming languages that include C, C++, Java, HTML, CSS, Bootstrap, JavaScript, PHP, Android, SQL and Algorithm.</p>
          </div>

          <div class="col-xs-6 col-md-3">
            <h6>Categories</h6>
            <ul class="footer-links">
              <li><a href="http://scanfcode.com/category/c-language/">C</a></li>
              <li><a href="http://scanfcode.com/category/front-end-development/">UI Design</a></li>
              <li><a href="http://scanfcode.com/category/back-end-development/">PHP</a></li>
              <li><a href="http://scanfcode.com/category/java-programming-language/">Java</a></li>
              <li><a href="http://scanfcode.com/category/android/">Android</a></li>
              <li><a href="http://scanfcode.com/category/templates/">Templates</a></li>
            </ul>
          </div>

          <div class="col-xs-6 col-md-3">
            <h6>Quick Links</h6>
            <ul class="footer-links">
              <li><a href="http://scanfcode.com/about/">About Us</a></li>
              <li><a href="http://scanfcode.com/contact/">Contact Us</a></li>
              <li><a href="http://scanfcode.com/contribute-at-scanfcode/">Contribute</a></li>
              <li><a href="http://scanfcode.com/privacy-policy/">Privacy Policy</a></li>
              <li><a href="http://scanfcode.com/sitemap/">Sitemap</a></li>
            </ul>
          </div>
        </div>
        <hr>
      </div>
      <div class="container">
        <div class="row">
          <div class="col-md-8 col-sm-6 col-xs-12">
            <p class="copyright-text">Copyright &copy; 2017 All Rights Reserved by 
         <a href="#">Scanfcode</a>.
            </p>
          </div>

          <div class="col-md-4 col-sm-6 col-xs-12">
            <ul class="social-icons">
              <li><a class="facebook" href="#"><i class="fa fa-facebook"></i></a></li>
              <li><a class="twitter" href="#"><i class="fa fa-twitter"></i></a></li>
              <li><a class="dribbble" href="#"><i class="fa fa-dribbble"></i></a></li>
              <li><a class="linkedin" href="#"><i class="fa fa-linkedin"></i></a></li>   
            </ul>
          </div>
        </div>
      </div>
</footer>
</body>

​<script>
  var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;

  // Biến mảng toàn cục chứa danh sách tên các thuộc tính
  const gUSER_COLS = ["userId", "firstname", "lastname", "age", "action"];
  
  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gUSER_ID_COL = 0;
  const gUSER_FIRSTNAME_COL = 1;
  const gUSER_LASTNAME_COL = 2;
  const gUSER_AGE_COL = 3;
  const gUSER_ACTION_COL = 4;

  var gUserObj = JSON.parse(gJsonUser);
  var gUserTable = $("#table-users").DataTable({
    data: gUserObj.users,
    columns: [
      { data: gUSER_COLS[gUSER_ID_COL] },
      { data: gUSER_COLS[gUSER_FIRSTNAME_COL] },
      { data: gUSER_COLS[gUSER_LASTNAME_COL] },
      { data: gUSER_COLS[gUSER_AGE_COL] },
      { data: gUSER_COLS[gUSER_ACTION_COL] }
    ],
    columnDefs: [
      {
        targets: gUSER_ACTION_COL,
        defaultContent: "<button class='btn btn-primary user-detail'>Chi tiết</button>"
      }
    ]
  });

  $("#table-users tbody").on("click", ".user-detail", function() {
    onUserDetailClick(this);
  });

  // hàm xử lý khi click vào nút user detail
  function onUserDetailClick(paramUserDetailBtn) {
    var vUserDetailBtn = $(paramUserDetailBtn);
    var vTableRow = vUserDetailBtn.parents("tr");
    var vDataTableRow = gUserTable.row(vTableRow);
    var vData = vDataTableRow.data();
    /***
     * TODO: xử lý tiếp để show dữ liệu user lên Modal 
     */
        
    $("#input-user-id").val(vData.userId);
    $("#input-firstname").val(vData.firstname);
    $("#input-lastname").val(vData.lastname);
    $("#input-age").val(vData.age);
    $("#modal-user-detail").modal("show");
  }

</script>
</html>